// Chasis basado en scout tribot: http://www.thingiverse.com/thing:13042

$fn=50;
//User Adjustable Parameters
TopPlate = 6; //thickness of top plate (in mm)
MountingHole = 1.3; //radius of controller board mounting holes (in mm)
Width = 93;
Length = 75;
CornerRadius = 4;

//Internal Constants
iwidth = Width-CornerRadius*2;
ilength = Length-CornerRadius*2;
holerad = 1.4;

//Piramides de hueco. Se romperán para poder albergar la placa de Arduino.
	espacio=9.4;

//Build the top plate
difference () {

union()
{

//Tope de la batería
   translate([Width/2-34,-Length/2,3]) {cube([30, 3, 7]);}

	difference() {
	translate([0-iwidth/2,0-ilength/2,0]){
		minkowski(){	
			cube(size = [iwidth,ilength,TopPlate/2]);
			cylinder(r=CornerRadius,h=TopPlate/2); }}
	{

	for(i=[0:4])
	translate([-41,-3*Length/8+2+espacio*i,-3]) {
		hull(){ cube([58,5,0.1]); translate([0,0,6])  cube([57,espacio-0.3,0.1]);}}
		
	translate([16,-Length/2+14,0]) {cube([0.3,Length-28,3]);}		
	translate([-41,-Length/2+14,0]) {cube([0.3,Length-28,3]);}		
	translate([-41,-3*Length/8+5.1*11-6.7,0]){cube([57.3,6.5,3]);}
	translate([-41,-3*Length/8+2,0]){cube([63,7.5,3]);}
	translate([15,-3*Length/8+1,0]){cube([5,15,3]);}

// Huecos para aligerar el contacto con la plataforma y evitar deformaciones de la base.
	for(i=[1:3])
	#translate([-Width/2+5,Length/2-1.3*i,0]) {cube([Width-10,0.5,0.54]);}
	for(i=[1:3])
	translate([-Width/2+5,-Length/2+1.3*i,0]) {cube([Width-10,0.5,0.54]);}

	}
	}


// Base del soporte.
translate([-7,0,0]){
	rotate([0,180,0]){
		union(){   //Soporte Arduino
			translate([31.8,8.85,-3]) {cylinder(r=3,h=3);}
			translate([31.8,-19.05,-3]) {cylinder(r=3,h=3);}
			translate([-20.3,-24.15,-3]) {cylinder(r=3,h=3);}
}}}
// Orejas. Opcional, mejoran la adherencia a la plataforma durante la impresión. Se deben eliminar despues. 
		color("cyan")	translate([Width/2,Length/2,0]) {cylinder(r=7,h=0.54);}
		color("cyan")	translate([Width/2,0-Length/2,0]) {cylinder(r=7,h=0.54);}
		color("cyan")	translate([0-Width/2,Length/2,0]) {cylinder(r=7,h=0.54);}
		color("cyan")	translate([0-Width/2,0-Length/2,0]) {cylinder(r=7,h=0.54);}

}
//optional holes:  These cutouts are unnecessary but reduce the amount of plastic  used, speed up print time, and make it easier to route wires.  Most sizes and positions are hard coded.

//battery hole
	translate([21.5,-29.5,-3]){
		minkowski(){
 			cube(size = [12.5,59,TopPlate*2]);
 			cylinder(r=3,h=TopPlate*2);
		} 
	}

//arduino hole
	translate([0-29.5,-29.5,-3]){
		minkowski(){
			cube(size = [26,59,TopPlate*2]);
 			cylinder(r=3,h=TopPlate*2);
		} 
	}

//arduino Mount Holes
	translate([-7,0,10]){
		rotate([0,180,0]){
			union(){
				translate([31.8,8.85,0]) {cylinder(r=holerad,h=TopPlate+40);}
				translate([31.8,-19.05,0]) {cylinder(r=holerad,h=TopPlate+40);}
				//translate([-19,24.05,0]) {cylinder(r=holerad,h=TopPlate+40);}
				translate([-20.3,-24.15,0]) {cylinder(r=holerad,h=TopPlate+40);}
			}
		}
	}


//Other Chassis Holes for mounting stuff
			translate([Width/2-5,Length/2-5,-2]) {cylinder(r=holerad,h=TopPlate+10);}
			translate([Width/2-5,0-Length/2+5,-2]) {cylinder(r=holerad,h=TopPlate+10);}
			translate([0-Width/2+5,Length/2-5,-2]) {cylinder(r=holerad,h=TopPlate+10);}
			translate([0-Width/2+5,0-Length/2+5,-2]) {cylinder(r=holerad,h=TopPlate+10);}
			translate([8.5,Length/2-5,-2]) {cylinder(r=holerad,h=TopPlate+10);}
			translate([8.5,0-Length/2+5,-2]) {cylinder(r=holerad,h=TopPlate+10);}
}

//Servo Legs
vgap = 10; //spacing between holes in short dimension of servo
hgap = 48; //spacing between holes in long dimension of servo
inset = 8; //spacing between legs and edge of top plate
//holerad = 1.3;
vspace = 6;  // spacing top plate and closest holes
hpos = 0- Width/2+4.7;
vpos = Length/2 - (inset + 2.5);

translate([hpos + hgap +2.5,vpos,0]) {leg (vgap, holerad, vspace);}
translate([hpos,0-vpos,0]) {leg (vgap, holerad, vspace);}

difference(){
  translate([hpos + hgap +2.5 ,0-vpos,0]) {leg (vgap, holerad, vspace);}
	translate([-7,0,30]) rotate([0,180,0]){translate([-20.3,-24.15,0]) {cylinder(r=holerad,h=TopPlate+40);}}}
translate([hpos,vpos,0]) {leg (vgap, holerad, vspace);}

//Battery clip

//User adjustable parameters.  The following are set for a standard 9V battery
batteryw = 26.2;
batteryh = 17.5;
ClipW = 6.5;  //width of the clip
ClipL = 21; //length of the clip

//internal constants
dimh = 4.242641;  // dimensions of the 3 cube after rotating 45 degrees

// Refuerzo rueda loca opcional.
// translate([Width/2+3,0,(batteryh+dimh/2)/2]) {cube([8, 4, batteryh+dimh/2], center=true);}

translate([Width/2 - batteryw/2 -ClipW ,0,0]){
	union(){
		translate([batteryw/2,0-ClipL/2,TopPlate]) {
			cube ([ClipW, ClipL, batteryh+dimh/2]);
			translate([0-dimh/2,0,batteryh]){
				rotate([0,45,0]){	
					cube([3,ClipL,3]);
				}
			}
		}
		rotate (a = [0,0,180]){
			translate([batteryw/2,0-ClipL/2,TopPlate]) {
				cube ([ClipW, ClipL, batteryh+dimh/2]);
				translate([0-dimh/2,0,batteryh]){
					rotate([0,45,0]){	
						cube([3,ClipL,3]);
					}
				}
			}
		}

	}
}

module leg (hole_space_v,  hole_radius, edge_buffer) {
	cubeheight = hole_space_v + (2* edge_buffer);
	cubeheight2 = hole_space_v;//mm
	translate ([0,0,(cubeheight/2)+(TopPlate)]){
		difference () {
			translate ([0,0,-(edge_buffer)]) cube([9.4,6,cubeheight2], center = true);
			rotate ([90,0,0]){ 
				translate ([0,0-hole_space_v/2-1 ,-5]) {cylinder (h = 10, r1 = hole_radius, r2 = hole_radius);}
			}
		}
	}
}


//This section builds the ball caster.

//user adjustable parameters
WallThickness = 2.25; //thickness of the retaining wall
BallSize = 16.5;  //diameter of  your ball bearing.
Airgap = .65;  // Gap between ball and wall
BallProtrude = .25; //percentage of ball radius sticking out 
WheelDiameter = 56;  //what size wheels you will use.

//internal constants
axlepos = TopPlate + vspace + vgap/2;
TotalHeight = axlepos + WheelDiameter/2;
cylrad = (BallSize/2) + WallThickness + Airgap;
echo (axlepos);
cylheight = TotalHeight;

difference (){
translate ([(Width/2)+WallThickness+1,0,0]){
	rotate( a = [0,0,90] ){
		difference () {
			cylinder(r1 = cylrad , r2 = cylrad,  cylheight - (BallSize*BallProtrude));

// Hueco agrandado y finalizado en redondo para mayor flexibilidad.
		hull(){
			translate([0,0,TotalHeight ]) {
				cube(size = [cylrad*2+10, cylrad, BallSize*1], center = true );
			}
			translate([0,0,TotalHeight - BallSize]) {
				rotate( [90,0,90] ) cylinder(r1=cylrad/4, r2=cylrad/4, h=30, center = true );
			}}
			#translate([0,0,TotalHeight - (BallSize/2)]) {
				sphere (BallSize/2+Airgap, $fa=5, $fs=0.1);
			}
			
		}
	}
}
union(){
translate ([Width/2,-15,0]){
	rotate (a = [0,20.2,0]){
		cube ([20,30,50]);
		}
	}
 translate ([Width/2-cylrad-2,-15,TopPlate]){
		cube ([cylrad,30,batteryh]);
		}
	}
}





//This will show the a rough aproximation of the wheels.  Useful for visualization.
%translate ([0-hgap/2,Length/2 + 5,axlepos]){
	rotate(a = [90,0,0]){
		cylinder (r1 = WheelDiameter/2, r2 = WheelDiameter/2, h = 4);}}
%translate ([0-hgap/2,-Length/2 - 5,axlepos]){
	rotate(a = [90,0,0]){
		cylinder (r1 = WheelDiameter/2, r2 = WheelDiameter/2, h = 4);
	}
}



