/* Soporte para sensor de ultrasonidos HC-SR04  y optoacopladores CNY-70
*/

$fn=30;


//Medidas del porta_ultrasonidos.
ancho=76;
alto=50;
fondo=22;
grosor=5;
grosor2=3.5;
// Distancia entre tornillos
d_tornilos=65;	
// Medidas del sensor

d_sensor=17;	//Diámetro del sensor
d_ext=44;		// Distancia entre el exterior de ambos sensores
anch_pl=46;	// Ancho de la placa
alt_pl=21;	// Alto de la placa

r_sensor=d_sensor/2; //radio de los sensores

                                           
module pestana1()
{
 translate([-4, -2.5, 0]) hull() {cube([4,5,0.54]); translate([2.9, 0, fondo-grosor2-12]) cube([1.5,5,1]);}
}

module pestana2()
{
 translate([0, -2.5, 0]) hull() {cube([5,5,2]); translate([-0.5, 0, 3]) cube([7.5,5,1]);}
}

module hueco_sensor()
{
	// Hueco del cristal o conector 12x6
	translate([0, -alt_pl/2+3, -grosor/2]) hull(){ translate([-3, 0, 0])cylinder(r=3,h=2*grosor);translate([3, 0, 0])cylinder(r=3,h=2*grosor);}  // Cristal/conector
	translate([0, alt_pl/2-3, -grosor/2]) hull(){ translate([-3, 0, 0])cylinder(r=3,h=2*grosor);translate([3, 0, 0])cylinder(r=3,h=2*grosor);}  // Cristal/conector
	hull(){ translate([-(d_ext/2-r_sensor), 0,-grosor/2]) cylinder(r = r_sensor, h = 2*grosor);
 		translate([d_ext/2-r_sensor,0,-grosor/2]) cylinder(r = r_sensor, h = grosor*2);}
}



module hueco_infrared()
{

translate([-3.6,0,0]) cube([7.2,6.2,7.2]);
translate([-3.6,-6,1]) cube([7.2,12.2,6.2]);
hull(){
translate([-3.6,4.5,0]) cube([7.2,0.2,7.2]);
translate([-4.1,7,-0.5]) cube([8.2,0.2,8.2]);}

}


module base(){
union() { 
   difference () {
       	translate([-ancho/2, 0, 0]) {cube([ancho,alto,grosor2]);}
 		translate([0, alt_pl/2+grosor, 0]){hueco_sensor();}
       }

//Refuerzos
       	translate([-(d_tornilos/2), grosor, grosor2]) rotate([0,0,-90]) pestana1();
       	translate([d_tornilos/2, grosor, grosor2]) rotate([0,0,-90]) pestana1();
 
//      Clips laterales para sujetar la placa de ultrasonidos. Se flexa ligeramente el soporte para que entre la placa de ultrasonidos. Si queda floja se añade una goma enganchada entre ambos clips.

      	translate([anch_pl/2, alt_pl/2+grosor, grosor2]) rotate([0,0,0]) pestana2();
       	translate([-anch_pl/2, alt_pl/2+grosor, grosor2]) rotate([0,0,180]) pestana2();

		

     difference () {
     	union() {	//Base de los tornillos.
		hull(){	translate([-ancho/2,0,0]) 
               cube([(ancho-anch_pl)/2+2,grosor,grosor]);
				translate([-d_tornilos/2,grosor,fondo-5])rotate([90,0,0]) cylinder(r=6,h=grosor);}
		hull(){	translate([ancho/2-(ancho-anch_pl)/2-2,0,0]) 
               cube([(ancho-anch_pl)/2+2,grosor,grosor]);
				translate([d_tornilos/2,grosor,fondo-5])rotate([90,0,0]) cylinder(r=6,h=grosor);}
		}
		{ 	// Agujeros de los tornillos
		translate([-d_tornilos/2,10,fondo-5]) rotate([90,0,0]) hull(){ translate([1,0,0])cylinder(r=1.6,h=20); translate([-1,0,0])cylinder(r=1.6,h=20);}
		translate([d_tornilos/2,10,fondo-5]) rotate([90,0,0]) hull(){ translate([1,0,0])cylinder(r=1.6,h=20); translate([-1,0,0])cylinder(r=1.6,h=20);}
		}
	}
}

// Base del soporte para infrarrojos.
translate([-ancho/2,alto-8,0]) cube([ancho,8,11]);


	//Orejas
//color("cyan")	translate([ancho/2,alto,0]) {cylinder(r=7,h=0.54);}
//color("cyan")	translate([ancho/2,0,0]) {cylinder(r=7,h=0.54);}
//color("cyan")	translate([0-ancho/2,alto,0]) {cylinder(r=7,h=0.54);}
//color("cyan")	translate([0-ancho/2,0,0]) {cylinder(r=7,h=0.54);}	
}


d1=-5; // Desplazamiento del orificio lateral respecto al centro vertical.

module soporte(){
difference(){
base();
for(i=[-3:3])
translate([i*10.3,alto-6.1,2]) hueco_infrared();
//for(i=[0:3])
//translate([ancho/2-6-i*9.1,alto-7.1,2]) hueco_infrared();
hull(){
translate([ancho/2-5,alto/2+d1,0]) cylinder(r=1.5,h=10,center=true);
translate([ancho/2-5,alto/2+d1+10,0]) cylinder(r=1.5,h=10,center=true);}
hull(){
translate([-ancho/2+5,alto/2+d1,0]) cylinder(r=1.5,h=10,center=true);
translate([-ancho/2+5,alto/2+d1+10,0]) cylinder(r=1.5,h=10,center=true);
}

for(i=[1:3]){
translate([-ancho/2+2+10.3*i,alto/2+6,0]) hull(){cylinder(r=1.3,h=10,center=true);translate([0,2,0]) cylinder(r=1.3,h=10,center=true);}
translate([ancho/2-(+2+10.3*i),alto/2+6,0]) hull(){cylinder(r=1.3,h=10,center=true);translate([0,2,0]) cylinder(r=1.3,h=10,center=true);}
}}}

soporte();



